<p align="center">
  <img src="misc/logo.png" alt="Vixeny Logo"  style="max-width: 100%;">
  <br>
  <em style="font-size:1.5em; color:darkcyan;">Empowering Development Through Functional Elegance</em>
  <br>
  <code>npx create-vixeny</code> | <code>bun create vixeny</code>
</p>

[![JSR](https://jsr.io/badges/@vixeny/core)](https://jsr.io/@vixeny/core)
[![npm version](https://img.shields.io/npm/v/vixeny.svg)](https://www.npmjs.com/package/vixeny)
![GitHub Actions status](https://github.com/mimiMonads/vixeny/workflows/Deno/badge.svg)
![GitHub Actions status](https://github.com/mimiMonads/vixeny/workflows/Bun/badge.svg)

**Vixeny: Pioneering Functional Web Development**

Vixeny is not just another framework; it's a comprehensive solution designed for
the modern web developer. At its core, Vixeny champions the principles of
functional programming—purity, immutability, and controlled side effects—without
compromising on the flexibility needed to blend with other programming
paradigms. Whether you're a seasoned functional programming enthusiast or
exploring this paradigm for the first time, Vixeny provides a robust,
performance-centric foundation for your web projects.

Easing into Vixeny is now smoother than ever, especially for those working
within Deno and Bun environments. By leveraging the simplicity of commands like
`npx create-vixeny` and `bun create vixeny`, developers can rapidly set up new
projects choosing from a variety of templates including vanilla JavaScript, Ejs,
or Pug, all equipped with hot reloading capabilities. This feature not only
simplifies the setup process but also significantly enhances productivity and
workflow efficiency.

**Why Choose Vixeny?**

- **Blazing-Fast Performance**: Lead the pack with the fastest execution times
  across the Deno and Bun ecosystems.
- **Minimalist Design**: A zero-dependency philosophy ensures that Vixeny
  remains lightweight, fast, and uncluttered.
- **Extensible Through Plugins**: Native support for plugins allows for seamless
  integration of additional functionality.
- **Ironclad Security**: Designed with security at its heart, Vixeny ensures
  your applications are safe and sound.
- **Sophisticated Type Checking**: Advanced type system integration for
  bulletproof code reliability emd-to-end.
- **Harmony of Paradigms**: While rooted in functional programming, Vixeny
  gracefully supports a spectrum of programming paradigms.
- **Seamless Testing**: Built from the ground up to accommodate easy and
  comprehensive testing strategies.
- **Future-Ready**: Stay at the forefront of web development with cutting-edge
  features and updates.

Embrace the future of web development with Vixeny, where functionality meets
sophistication. Get started today and experience the difference. **Benchmarks**

```bash
npx create-vixeny
```

- [JWT Benchmark](https://github.com/mimiMonads/FrameworkBench)
- [Bun by SaltyAom](https://github.com/SaltyAom/bun-http-framework-benchmark)

**License:**
[CC BY-ND 4.0](https://creativecommons.org/licenses/by-nd/4.0/legalcode.txt)
